<template>
  <sui-modal
    v-model="visible"
    size="mini"
    class="confirm"
    :animation-duration="1"
    v-dom-move
    v-scroll-lock="verifyPhoneModalShow">
    <i
      class="close icon"
      @click="hideModal"/>
    <div class="header white"/>
    <div class="content">
      <div class="title">
        Подтвердите свой телефон
        <div class="text">На ваш номер отправлено sms <br>с кодом подтверждения</div>
      </div>
      <div class="ui form">
        <div class="field">
          <label>Введите код</label>
          <div class="ui input">
            <masked-input
              v-model.lazy="code"
              @input="changeVerifyCode($event)"
              :mask="codeMask"
              :masked="true"
              placeholder="Введите код"
              type="text"/>
          </div>
        </div>
        <div
          v-if="errorMessage"
          class="field"
          style="text-align: center">
          {{ errorMessage }}
        </div>
        <div
          v-if="counting"
          class="field">
          <p class="text">Выслать код повторно через</p>
          <div class="code-timer">{{ `0${minutes}` }}:{{ seconds>9? seconds : `0${seconds}` }}</div>
        </div>
        <div
          v-else
          class="field">
          <div
            class="ui button blue small fluid"
            @click="restart">Выслать код еще раз</div>
        </div>
      </div>
    </div>
  </sui-modal>
</template>

<script>
import { TheMask } from 'vue-the-mask';

export default {
  name: 'VerifyPhone',
  components: {
    'masked-input': TheMask,
  },
  model: {
    prop: 'verifyPhoneModalShow',
    event: 'change',
  },
  props: {
    verifyPhoneModalShow: {
      type: Boolean,
      required: true,
    },
    isCounting: {
      type: Boolean,
      required: true,
    },
    errorMessage: {
      type: String,
      required: true,
    },
  },
  data() {
    const time = 2 * 60 * 1000;
    const endTime = Date.now() + time;

    return {
      code: null,
      codeMask: '#####',
      endTime,
      counting: false,
      time,
      remainingTime: time,
      interval: 1000,
      timerId: null,
    };
  },
  computed: {
    minutes() {
      return Math.floor(this.remainingTime / 60000);
    },
    seconds() {
      return Math.floor((this.remainingTime % 60000) / 1000);
    },
    visible: {
      get() {
        return this.verifyPhoneModalShow;
      },
      set(newVal) {
        if (newVal) {
          this.$emit('change', true);
        } else {
          this.hideModal();
        }
      },
    },
  },
  watch: {
    'isCounting'(started) {
      if (started && !this.counting) {
        this.start();
      }
    },
  },
  beforeDestroy() {
    this.reset();
  },
  methods: {
    hideModal() {
      this.$emit('close');
      this.$emit('change', false);
    },
    reset() { // vs for start
      this.counting = false;
      this.endTime = 0;
      this.remainingTime = 0;
      clearTimeout(this.timerId);
    },
    restart() {
      this.reset();
      this.$emit('sendAgain');
    },
    start() { // vs for reset
      this.counting = true;
      this.endTime = Date.now() + this.time;
      this.remainingTime = this.time;
      this.timerId = setTimeout(() => {
        this.progress();
      }, this.interval);
    },
    progress() {
      if (!this.counting) {
        return;
      }

      this.remainingTime = this.endTime - Date.now();

      if (this.remainingTime <= 0) {
        this.counting = false;
        this.$emit('timeIsUp');
        this.reset();
        return;
      }
      this.timerId = setTimeout(() => {
        this.progress();
      }, this.interval);
    },
    changeVerifyCode(value) {
      if (value && value.length === 5) {
        this.$emit('input', value);
      }
    },
  },
};
</script>

<style scoped lang="scss">
  .ui.modal {
    > .content {
      max-width: 18rem;
      margin: 0 auto;
      padding: 0 2rem 2rem;
      @media screen and (max-width: 980px) {
        padding-bottom: 2.5rem !important;
      }
      .title {
        display: block;
        font-size: 1rem;
        line-height: 1.3;
        font-weight: 500;
        text-align: center;
        @media screen and (max-width: 980px) {
          font-size: 1.125rem;
        }
        .text {
          padding: 0.5rem 0 1.5rem;
        }
      }
      .text {
        display: block;
        margin: 0;
        font-size: 0.8125rem;
        line-height: 1.3;
        font-weight: 400;
        color: #4a4a4a;
        text-align: center;
        padding: 0;
        @media screen and (max-width: 980px) {
          font-size: 0.9375rem;
        }
      }
      .code-timer {
        text-align: center;
        font-size: 1.3125rem;
        padding-top: 0.5rem;
      }
    }
  }

</style>
